# AUTOGENERATED! DO NOT EDIT! File to edit: ../../pascal_nsbs/12_accel_sgd.ipynb.

# %% auto 0
__all__ = ['BaseSchedCB', 'BatchSchedCB', 'HasLearnCB', 'RecorderCB', 'EpochSchedCB']

# %% ../../pascal_nsbs/12_accel_sgd.ipynb 2
import torch

from miniai.datasets import *
from miniai.conv import *
from miniai.learner import *
from miniai.activations import *
from miniai.init import *

# %% ../../pascal_nsbs/12_accel_sgd.ipynb 45
class BaseSchedCB(Callback):
    def __init__(self, sched): self.sched = sched
    def before_fit(self, learn): self.schedo = self.sched(learn.opt)
    def _step(self, learn):
        if learn.training: self.schedo.step()

# %% ../../pascal_nsbs/12_accel_sgd.ipynb 46
class BatchSchedCB(BaseSchedCB):
    def after_batch(self, learn): self._step(learn)

# %% ../../pascal_nsbs/12_accel_sgd.ipynb 47
class HasLearnCB(Callback):
    def before_fit(self, learn): self.learn = learn 
    def after_fit(self, learn): self.learn = None

# %% ../../pascal_nsbs/12_accel_sgd.ipynb 48
class RecorderCB(Callback):
    def __init__(self, **d): self.d = d
    def before_fit(self, learn):
        self.recs = {k:[] for k in self.d}
        self.pg = learn.opt.param_groups[0]
    
    def after_batch(self, learn):
        if not learn.training: return
        for k,v in self.d.items():
            self.recs[k].append(v(self))

    def plot(self):
        for k,v in self.recs.items():
            plt.plot(v, label=k)
            plt.legend()
            plt.show()

# %% ../../pascal_nsbs/12_accel_sgd.ipynb 54
class EpochSchedCB(BaseSchedCB):
    def after_epoch(self, learn): self._step(learn)
